Index: main/plugin-forms/src/org/ametys/plugins/forms/table/FormTableManager.java
===================================================================
--- main/plugin-forms/src/org/ametys/plugins/forms/table/FormTableManager.java	(revision 40266)
+++ main/plugin-forms/src/org/ametys/plugins/forms/table/FormTableManager.java	(working copy)
@@ -25,6 +25,7 @@
 import java.sql.Timestamp;
 import java.sql.Types;
 import java.util.ArrayList;
+import java.util.Collections;
 import java.util.HashMap;
 import java.util.LinkedHashMap;
 import java.util.List;
@@ -59,7 +60,10 @@
 
     /** Creation date field name. */
     public static final String CREATION_DATE_FIELD = "creationDate";
-
+    
+    /** Workflow id column name. */
+    public static final String WORKFLOW_ID_FIELD = "workflowId"; 
+    
     /** Suffix for filename column. */
     public static final String FILE_NAME_COLUMN_SUFFIX = "-filename";
 
@@ -179,18 +183,19 @@
      * Get all the submissions for a form.
      * 
      * @param form the form object.
-     * @param columns
+     * @param columns the columns
      * @param offset The number of results to ignore.
      * @param length The maximum number of results to return.
+     * @param entryIds the ids of the submissions to retrieve
      * @return the list of submissions.
      * @throws FormsException if an error occurs.
      */
-    public List<UserEntry> getSubmissions(Form form, Map<String, FieldValue> columns, int offset, int length) throws FormsException
+    public List<UserEntry> getSubmissions(Form form, Map<String, FieldValue> columns, int offset, int length, List<Integer> entryIds) throws FormsException
     {
         List<UserEntry> entries = new ArrayList<UserEntry>();
 
         final String tableName = TABLE_PREFIX + form.getId();
-
+        
         Connection con = null;
         PreparedStatement stmt = null;
         ResultSet rs = null;
@@ -290,9 +295,18 @@
                             break;
                     }
                 }
+                
+                Integer workflowId = null;
+                if (hasWorkflowIdColumn(form.getId()))
+                {
+                    workflowId = rs.getInt(WORKFLOW_ID_FIELD);
+                }
 
-                UserEntry entry = new UserEntry(id, creationDate, entryValues);
-                entries.add(entry);
+                if (entryIds == null || entryIds.contains(id))
+                {
+                    UserEntry entry = new UserEntry(id, creationDate, entryValues, workflowId);
+                    entries.add(entry);
+                }
             }
         }
         catch (SQLException e)
@@ -592,7 +606,7 @@
 
             // Move the columns that were deleted or replaced.
             _moveColumns(con, modifications.getColumnsToRemove(), existingColumns, tableName);
-
+            
             // Add the new columns.
             _addColumns(con, modifications.getColumnsToAdd(), tableName);
 
@@ -650,7 +664,7 @@
             }
 
             currentColumns = _getExistingColumns(con, tableName);
-
+            
             for (String newColumn : newColumns.keySet())
             {
                 String filteredColumn = DbTypeHelper.filterName(dbType, newColumn);
@@ -748,6 +762,7 @@
 
         modifications.setColumnsToAdd(columnsToAdd);
         modifications.setColumnsToRemove(columnsToRemove);
+        
 
         return modifications;
     }
@@ -840,7 +855,7 @@
             throw e;
         }
     }
-
+    
     private void _addColumns(Connection con, Map<String, FieldValue> columnsToAdd, String tableName) throws SQLException
     {
         DatabaseType dbType = ConnectionHelper.getDatabaseType(con);
@@ -960,16 +975,148 @@
         }
         return sqlType;
     }
+    
+    /**
+     * Add a workflow id column to the given table
+     * @param formId the id of the form to alter
+     * @throws FormsException if an error occurs
+     */
+    public void addWorkflowIdColumn(String formId) throws FormsException
+    {
+        final String tableName = TABLE_PREFIX + formId;
+        
+        Connection con = null;
+        PreparedStatement stmt = null;
+        
+        try
+        {
+            // Connect to the database.
+            con = ConnectionHelper.getConnection(ConnectionHelper.CORE_POOL_NAME);
+            DatabaseType dbType = ConnectionHelper.getDatabaseType(con);
+            StringBuilder sql = new StringBuilder();
+
+            sql.append("ALTER TABLE ").append(DbTypeHelper.escape(dbType, tableName));
+            sql.append(" ADD ").append(WORKFLOW_ID_FIELD).append(" ");
+            sql.append(DbTypeHelper.getIntegerType(dbType));
+
+            if (__logger.isDebugEnabled())
+            {
+                __logger.debug("Adding column: " + sql.toString());
+            }
+
+            stmt = con.prepareStatement(sql.toString());
+            stmt.executeUpdate();
+        }
+        catch (SQLException e)
+        {
+            __logger.error("Error while adding the workflow id column for the table " + tableName, e);
+            throw new FormsException("Error while adding a column to the table " + tableName, e);
+        }
+        finally
+        {
+            // Clean up connection resources
+            ConnectionHelper.cleanup(stmt);
+            ConnectionHelper.cleanup(con);
+        }
+    }
+    
+    /**
+     * Delete the workflow id column of the given table
+     * @param formId the id of the form to alter
+     * @throws FormsException if an error occurs
+     */
+    public void dropWorkflowIdColumn(String formId) throws FormsException
+    {
+        final String tableName = TABLE_PREFIX + formId;
+        
+        Connection con = null;
+        PreparedStatement stmt = null;
+        
+        try
+        {
+            // Connect to the database.
+            con = ConnectionHelper.getConnection(ConnectionHelper.CORE_POOL_NAME);
+            DatabaseType dbType = ConnectionHelper.getDatabaseType(con);
+            StringBuilder sql = new StringBuilder();
+
+            sql.append("ALTER TABLE ").append(DbTypeHelper.escape(dbType, tableName));
+            sql.append(" DROP COLUMN ").append(WORKFLOW_ID_FIELD).append(";");
+
+            if (__logger.isDebugEnabled())
+            {
+                __logger.debug("Deleting column: " + sql.toString());
+            }
+
+            stmt = con.prepareStatement(sql.toString());
+            stmt.executeUpdate();
+        }
+        catch (SQLException e)
+        {
+            __logger.error("Error while deleting the workflow id column for the table " + tableName, e);
+            throw new FormsException("Error while deleting a column from the table " + tableName, e);
+        }
+        finally
+        {
+            // Clean up connection resources
+            ConnectionHelper.cleanup(stmt);
+            ConnectionHelper.cleanup(con);
+        }
+    }
+
+    /**
+     * Set a new workflow id to the column that has the given old workflow id
+     * @param form the form
+     * @param entryId the id of the entry
+     * @param newWorkflowId the new workflow id
+     * @throws FormsException if an error occurs
+     */
+    public void setWorkflowId(Form form, long entryId, long newWorkflowId) throws FormsException
+    {
+        final String tableName = TABLE_PREFIX + form.getId();
+
+        Connection con = null;
+        PreparedStatement stmt = null;
+        
+        try
+        {
+            // Connect to the database.
+            con = ConnectionHelper.getConnection(ConnectionHelper.CORE_POOL_NAME);
+            DatabaseType dbType = ConnectionHelper.getDatabaseType(con);
+            
+            String query = "UPDATE " + DbTypeHelper.escape(dbType, tableName);
+            query += " SET "  + WORKFLOW_ID_FIELD + " = ?";
+            query += " WHERE " + ID_FIELD + " = ?";
+
+            stmt = con.prepareStatement(query);
+
+            stmt.setLong(1, newWorkflowId);
+            stmt.setLong(2, entryId);
 
+            // Execute the query.
+            stmt.executeUpdate();
+        }
+        catch (SQLException e)
+        {
+            __logger.error("Error while resetting the workflow id for the table " + tableName, e);
+            throw new FormsException("Error while deleting entry for table " + tableName, e);
+        }
+        finally
+        {
+            // Clean up connection resources
+            ConnectionHelper.cleanup(stmt);
+            ConnectionHelper.cleanup(con);
+        }
+    }
+    
     /**
      * Delete the submission from a form.
-     * @param form the form object.
+     * @param formId the id of the form.
      * @param entryId the entry to delete. If null, all the entries are deleted.
      * @throws FormsException if an error occurs.
      */
-    public void deleteSubmission(Form form, Integer entryId) throws FormsException
+    public void deleteSubmission(String formId, Integer entryId) throws FormsException
     {
-        final String tableName = TABLE_PREFIX + form.getId();
+        final String tableName = TABLE_PREFIX + formId;
 
         Connection con = null;
         PreparedStatement stmt = null;
@@ -1009,6 +1156,103 @@
             ConnectionHelper.cleanup(con);
         }
     }
+    
+    /**
+     * Get the workflow id of the given form entry or of all the entries
+     * @param formId the id of the form
+     * @param entryId the entry to get the workflow id from. If null, all the workflow ids are returned
+     * @throws FormsException if an error occurs.
+     * @return the list of workflow ids
+     */
+    public List<Integer> getWorkflowIds(String formId, Integer entryId) throws FormsException
+    {
+        if (!hasWorkflowIdColumn(formId))
+        {
+            return Collections.EMPTY_LIST;
+        }
+        
+        List<Integer> workflowIds = new ArrayList<Integer> ();
+
+        final String tableName = TABLE_PREFIX + formId;
+        
+        Connection con = null;
+        PreparedStatement stmt = null;
+        ResultSet rs = null;
+        
+        try
+        {
+            // Connect to the database.
+            con = ConnectionHelper.getConnection(ConnectionHelper.CORE_POOL_NAME);
+            DatabaseType dbType = ConnectionHelper.getDatabaseType(con);
+            
+            String query = "SELECT workflowId FROM " + DbTypeHelper.escape(dbType, tableName);
+            if (entryId != null)
+            {
+                query += " WHERE " + ID_FIELD + " = ?";
+            }
+
+            stmt = con.prepareStatement(query);
+
+            if (entryId != null)
+            {
+                stmt.setInt(1, entryId);
+            }
+            
+            // Execute the query.
+            rs = stmt.executeQuery();
+
+            // Extract the result(s).
+            while (rs.next())
+            {
+                workflowIds.add(rs.getInt(1));
+            }
+        }
+        catch (SQLException e)
+        {
+            __logger.error("Error while getting workflow ids from the table " + tableName, e);
+            throw new FormsException("Error while getting workflow ids from the table " + tableName, e);
+        }
+        finally
+        {
+            // Clean up connection resources
+            ConnectionHelper.cleanup(rs);
+            ConnectionHelper.cleanup(stmt);
+            ConnectionHelper.cleanup(con);
+        }
+
+        return workflowIds;
+    }
+    
+    /**
+     * Does the given form have a workflow id column in its SQL table ?
+     * @param formId the id of the form
+     * @return true if the form has a workflow id column, false otherwise
+     */
+    public boolean hasWorkflowIdColumn (String formId)
+    {
+        boolean hasWorkflowId = true;
+        
+        Connection con = null;
+        final String tableName = TABLE_PREFIX + formId;
+        
+        try
+        {
+            con = ConnectionHelper.getConnection(ConnectionHelper.CORE_POOL_NAME);
+            Map<String, DbColumn> currentColumns = _getExistingColumns(con, tableName);        
+            
+            // Check if the column contains a workflow id
+            if (!currentColumns.containsKey(WORKFLOW_ID_FIELD))
+            {
+                hasWorkflowId = false;
+            }
+            
+            return hasWorkflowId;
+        }
+        finally 
+        {
+            ConnectionHelper.cleanup(con);
+        }
+    }
 
     /**
      * Class storing modifications to do on columns.
@@ -1021,7 +1265,7 @@
 
         /** The columns to remove. */
         protected Map<String, FieldValue> _columnsToAdd;
-
+        
         /**
          * Build a DbColumnModifications object.
          */
@@ -1076,7 +1320,6 @@
         {
             this._columnsToAdd = columnsToAdd;
         }
-
     }
 
     /**
Index: main/plugin-forms/src/org/ametys/plugins/forms/workflow/FormEditionFunction.java
===================================================================
--- main/plugin-forms/src/org/ametys/plugins/forms/workflow/FormEditionFunction.java	(revision 40266)
+++ main/plugin-forms/src/org/ametys/plugins/forms/workflow/FormEditionFunction.java	(working copy)
@@ -1,5 +1,5 @@
 /*
- *  Copyright 2010 Anyware Services
+ *  Copyright 2016 Anyware Services
  *
  *  Licensed under the Apache License, Version 2.0 (the "License");
  *  you may not use this file except in compliance with the License.
@@ -68,7 +68,7 @@
             LockableAmetysObject lockableContent = (LockableAmetysObject) content;
             if (lockableContent.isLocked() && !LockHelper.isLockOwner(lockableContent, login))
             {
-                throw new WorkflowException("User '" + login + "' try to save content '" + content.getName() + "' but it is locked by another user");
+                throw new WorkflowException("User '" + login + "' is trying to save the content '" + content.getName() + "' but it is locked by another user.");
             }
             
             _checkLock (content);
@@ -76,19 +76,19 @@
         }
         catch (RepositoryException e)
         {
-            throw new WorkflowException("Unable to check lock for content " + content.getName() + "", e);
+            throw new WorkflowException("Unable to check the lock for the content " + content.getName() + "", e);
         }
         catch (AmetysRepositoryException e)
         {
-            throw new WorkflowException("Unable to edit content " + content.getName() + " from the repository", e);
+            throw new WorkflowException("Unable to edit the content " + content.getName() + " from the repository", e);
         }
         catch (SAXException e)
         {
-            _logger.error("An exception occured while parsing the form", e);
+            _logger.error("An exception occurred while parsing the form", e);
         }
         catch (IOException e)
         {
-            _logger.error("An exception occured while parsing the form", e);
+            _logger.error("An exception occurred while parsing the form", e);
         }
     }
     
Index: main/plugin-forms/src/org/ametys/plugins/forms/workflow/FormEntriesWorkflow.java
===================================================================
--- main/plugin-forms/src/org/ametys/plugins/forms/workflow/FormEntriesWorkflow.java	(revision 0)
+++ main/plugin-forms/src/org/ametys/plugins/forms/workflow/FormEntriesWorkflow.java	(revision 0)
@@ -0,0 +1,39 @@
+/*
+ *  Copyright 2016 Anyware Services
+ *
+ *  Licensed under the Apache License, Version 2.0 (the "License");
+ *  you may not use this file except in compliance with the License.
+ *  You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ *  Unless required by applicable law or agreed to in writing, software
+ *  distributed under the License is distributed on an "AS IS" BASIS,
+ *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ *  See the License for the specific language governing permissions and
+ *  limitations under the License.
+ */
+package org.ametys.plugins.forms.workflow;
+
+import org.apache.avalon.framework.service.ServiceException;
+
+import org.ametys.plugins.workflow.Workflow;
+import org.ametys.plugins.workflow.store.JdbcWorkflowStore;
+
+import com.opensymphony.workflow.spi.WorkflowStore;
+
+/**
+ * Singleton for manipulating workflow instances on form entries. 
+ */
+public class FormEntriesWorkflow extends Workflow
+{
+    /** The Avalon Role */
+    @SuppressWarnings("hiding")
+    public static final String ROLE = FormEntriesWorkflow.class.getName();
+    
+    @Override
+    protected WorkflowStore _getWorkflowStore() throws ServiceException
+    {
+        return (WorkflowStore) _manager.lookup(JdbcWorkflowStore.ROLE);
+    }
+}
Index: main/plugin-forms/src/org/ametys/plugins/forms/workflow/FormEntriesWorkflowAction.java
===================================================================
--- main/plugin-forms/src/org/ametys/plugins/forms/workflow/FormEntriesWorkflowAction.java	(revision 0)
+++ main/plugin-forms/src/org/ametys/plugins/forms/workflow/FormEntriesWorkflowAction.java	(revision 0)
@@ -0,0 +1,162 @@
+/*
+ *  Copyright 2016 Anyware Services
+ *
+ *  Licensed under the Apache License, Version 2.0 (the "License");
+ *  you may not use this file except in compliance with the License.
+ *  You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ *  Unless required by applicable law or agreed to in writing, software
+ *  distributed under the License is distributed on an "AS IS" BASIS,
+ *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ *  See the License for the specific language governing permissions and
+ *  limitations under the License.
+ */
+package org.ametys.plugins.forms.workflow;
+
+import java.util.ArrayList;
+import java.util.Arrays;
+import java.util.HashMap;
+import java.util.List;
+import java.util.Map;
+
+import org.apache.avalon.framework.parameters.Parameters;
+import org.apache.avalon.framework.service.ServiceException;
+import org.apache.avalon.framework.service.ServiceManager;
+import org.apache.cocoon.environment.ObjectModelHelper;
+import org.apache.cocoon.environment.Redirector;
+import org.apache.cocoon.environment.Request;
+import org.apache.commons.collections.MapUtils;
+
+import org.ametys.cms.repository.Content;
+import org.ametys.cms.workflow.AbstractContentWorkflowComponent;
+import org.ametys.plugins.forms.Form;
+import org.ametys.plugins.forms.data.FieldValue;
+import org.ametys.plugins.forms.data.UserEntry;
+import org.ametys.plugins.forms.jcr.FormPropertiesManager;
+import org.ametys.plugins.forms.table.FormTableManager;
+import org.ametys.plugins.workflow.cocoon.WorkflowAction;
+import org.ametys.runtime.user.CurrentUserProvider;
+import org.ametys.runtime.user.User;
+import org.ametys.runtime.user.UsersManager;
+import org.ametys.runtime.util.JSONUtils;
+import org.ametys.runtime.util.cocoon.ActionResultGenerator;
+
+import com.opensymphony.workflow.InvalidInputException;
+import com.opensymphony.workflow.WorkflowException;
+
+/**
+ * Action for firing a transition on a form entry workflow.<p>
+ * The following parameters are supported:
+ * <dl>
+ *  <dt>actionId
+ *  <dd>the id of the action to fire
+ * </dl>
+ */
+public class FormEntriesWorkflowAction extends WorkflowAction
+{
+    /** Component gathering utility methods to work with the forms JCR representations */
+    private FormPropertiesManager _formPropertiesManager;
+    
+    /** Helper to manipulation the forms SQL tables */
+    private FormTableManager _formTableManager;
+    
+    /** Workflow component for form entries */
+    private FormEntriesWorkflow _formEntriesWorkflow;
+    
+    /** Helper to retrieve the current user */
+    private CurrentUserProvider _currentUserProvider;
+    
+    /** The users manager */
+    private UsersManager _usersManager;
+
+    @Override
+    public void service(ServiceManager serviceManager) throws ServiceException
+    {
+        super.service(serviceManager);
+        _formEntriesWorkflow = (FormEntriesWorkflow) serviceManager.lookup(FormEntriesWorkflow.ROLE);
+        _formPropertiesManager = (FormPropertiesManager) serviceManager.lookup(FormPropertiesManager.ROLE);
+        _formTableManager = new FormTableManager();
+        _currentUserProvider = (CurrentUserProvider) serviceManager.lookup(CurrentUserProvider.ROLE);
+        _usersManager = (UsersManager) serviceManager.lookup(UsersManager.ROLE);
+    }
+    
+    @Override
+    protected Map _act(Redirector redirector, Map objectModel, String source, Parameters parameters, int actionId, Map inputs) throws InvalidInputException, WorkflowException
+    {
+        _formEntriesWorkflow.doAction(_getWorkflowId(objectModel, source, parameters), actionId, inputs);
+        return _getActionResult(redirector, objectModel, source, parameters);
+    }
+    
+    @Override
+    protected long _getWorkflowId(Map objectModel, String source, Parameters parameters)
+    {
+        try
+        {
+            String entryId = parameters.getParameter("entryId");
+            String formId = parameters.getParameter("formId");
+        
+            Form form = _formPropertiesManager.getForm(formId);
+            Map<String, FieldValue> columns = _formTableManager.getColumns(form);
+           
+            List<UserEntry> submissions = _formTableManager.getSubmissions(form, columns, 0, Integer.MAX_VALUE, new ArrayList<Integer>(Arrays.asList(Integer.valueOf(entryId))));
+        
+            if (submissions.isEmpty())
+            {
+                throw new RuntimeException("Unable to retrieve the workflow id for the entry '" + entryId + "' of the form '" + formId + "'.");
+            }
+            else
+            {
+                return submissions.get(0).getWorkflowId();
+            }
+        }
+        catch (Exception e)
+        {
+            throw new RuntimeException("Missing parameter workflowId", e);
+        }
+    }
+    
+    @Override
+    protected Map<String, Object> _getInputs(Redirector redirector, Map objectModel, String source, Parameters parameters) throws Exception
+    {
+        Map<String, Object> inputs = super._getInputs(redirector, objectModel, source, parameters);
+        
+        String formId = parameters.getParameter("formId");
+        Content formContent = _formPropertiesManager.getFormContent(formId);
+        // Provide the content key
+        inputs.put(AbstractContentWorkflowComponent.CONTENT_KEY, formContent);
+        
+        // Provide a map for providing data to the generator
+        Request request = ObjectModelHelper.getRequest(objectModel);
+        Map<String, Object> result = new HashMap<String, Object>();
+        request.setAttribute(ActionResultGenerator.MAP_REQUEST_ATTR, result);
+        inputs.put(AbstractContentWorkflowComponent.RESULT_MAP_KEY, result);
+        
+        // Set the workflow comment into the inputs.
+        String comment = request.getParameter("comment");
+        inputs.put("comment", comment);
+        
+        // Set the values for the information request function if a mail is to be sent
+        String furtherInfoAsJSON = request.getParameter("furtherInfo");
+        Map<String, Object> furtherInfo = JSONUtils.parse(furtherInfoAsJSON); 
+        if (MapUtils.isNotEmpty(furtherInfo))
+        {
+            // Retrieve the current user name and email
+            String login = _currentUserProvider.getUser();
+            User user = _usersManager.getUser(login);
+            
+            inputs.put(RequestInformationFunction.SENDER, user.getEmail());
+            inputs.put(RequestInformationFunction.RECIPIENT, furtherInfo.get("recipient"));
+            inputs.put(RequestInformationFunction.SUBJECT, furtherInfo.get("subject"));
+            inputs.put(RequestInformationFunction.BODY, furtherInfo.get("body"));
+        }
+        else
+        {
+            inputs.put(RequestInformationFunction.SEND_MAIL, "false");
+        }
+        
+        
+        return inputs;
+    }
+}
